import React from 'react';
import { Button, message, Spin , Alert  } from 'antd';
import { $Axios } from '../../common/publish';
import '../Layout/Layout.scss'
import styleData from '../moduleCss/style.module.scss';
import CenterO from '../center-o/centerO.jsx'
import CenterW from '../center-w/centerW.jsx'
import CenterS from '../center-s/centerS.jsx'
export default class Layout extends React.Component {
    constructor(props) {
        super(props)
        this.state = {
            headTxt: '商户入网 > 商户基本信息',
            htmls: 1,
            initHtmls: 1,
            Params_o: {},
            Params_w: {},
            Params_S: {},
            signedType: '',
            lodings : true,
            btnType : '',
            registerRole :''
        }

    }

    componentDidMount() {
        let that_ = this;
        setTimeout(function(){ that_.setState({lodings : false}) }, 1000);
    }

    handleChange(value) {
        console.log(`Selected: ${value}`);
    }
    bindRef_o = ref => { this.CenterO = ref }
    bindRef_w = ref => { this.CenterW = ref }
    bindRef_s = ref => { this.CenterS = ref }

    onCloseType(value) {
        this.setState({
            btnType: false
        });
    }
    Validation_data(e) {
        let data = '';
        let flag = true;
        if (e == 1) {
            data = JSON.parse(localStorage.getItem('oData'));
            this.setState({
                signedType: data.signedType,
                registerRole : data.registerRole 
            });
            if (data.signedName == '') {
                this.messageTK('请输入签约名称')
                flag = false
                return flag
            };
            if (data.registerRole == '') {
                this.messageTK('请选择商户签约性质')
                flag = false
                return flag
            };
            if (data.signedShorthand == '') {
                this.messageTK('请输入商户简称')
                flag = false
                return flag
            };
            if (data.contactName == '') {
                this.messageTK('请输入联系人姓名')
                flag = false
                return flag
            };
            if (data.contactEmail == '') {
                this.messageTK('请输入联系人邮箱')
                flag = false
                return flag
            };
            if (data.contactPhone == '') {
                this.messageTK('请输入联系人电话')
                flag = false
                return flag
            };
            if (data.businessAddressProvince == '') {
                this.messageTK('请选择经营地省')
                flag = false
                return flag
            };
            if (data.businessAddressCity == '') {
                this.messageTK('请选择经营地市')
                flag = false
                return flag
            };
            return flag
            
        } else if (e == 2) {
            data = JSON.parse(localStorage.getItem('wData'));
            if (data.legalPersonName == '') {
                this.messageTK('请输入法人姓名')
                flag = false
                return flag
            };
            if (data.legalPersonIdType == '') {
                this.messageTK('请选择法人证件类型')
                flag = false
                return flag
            };
            if (data.legalPersonIdNo == '') {
                this.messageTK('请输入法人证件号码')
                flag = false
                return flag
            };
            if (data.legalPersonIdNo == '') {
                this.messageTK('请输入法人证件号码')
                flag = false
                return flag
            };
            if (this.state.signedType !== 'NATURAL_PERSON') { //法人不为自然人时
                if (data.cerNoType == '') {
                    this.messageTK('请选择企业证件类型')
                    flag = false
                    return flag
                };
                if (data.cerNo == '') {
                    this.messageTK('请输入资质证书编号')
                    flag = false
                    return flag
                };
                if (data.sellingArea == '') {
                    this.messageTK('请选择营业面积')
                    flag = false
                    return flag
                };
                if (data.staffSize == '') {
                    this.messageTK('请选择员工规模')
                    flag = false
                    return flag
                };
                if (data.staffSize == '') {
                    this.messageTK('请选择员工规模')
                    flag = false
                    return flag
                };
            }
            if (data.legalIdCardProsPath == '') {
                this.messageTK('请上传法人证件人像面图片')
                flag = false
                return flag
            };
            if (data.legalIdCardConsPath == '') {
                this.messageTK('请上传法人证件国徽图片')
                flag = false
                return flag
            };
            return flag

        } else if (e == 3) {
            data = JSON.parse(localStorage.getItem('sData'));
            console.log(data)
            if (data.accountName == '') {
                this.messageTK('请输入开户名称')
                flag = false
                return flag
            };
            if (data.bankCardNo == '') {
                this.messageTK('请输入开户账号')
                flag = false
                return flag
            };
            if (data.provinceCode == '') {
                this.messageTK('请选择省编码')
                flag = false
                return flag
            };
            if (data.cityCode == '') {
                this.messageTK('请选择市编码')
                flag = false
                return flag
            };
            if(data.accountType == 'PUBLIC'){
                if (data.bankCode == '') {
                    this.messageTK('请选择开户行')
                    flag = false
                    return flag
                };
                if (data.bankBranchName == '') {
                    this.messageTK('请输入支行名称')
                    flag = false
                    return flag
                };
            }
            if (data.withdrawRate == '') {
                this.messageTK('请输入体现费率')
                flag = false
                return flag
            };
            return flag

        }
    }

    messageTK(e){
        message.error({
            content: e,
            className: 'custom-class',
            style: {
              marginTop: '20%',
            },
            onClose : this.onCloseType.bind(this)
          });
        this.setState({
            btnType: true
        });
    }



    btnClick_1() {
        let headTxt = '商户入网 > 商户资质信息'
        let that_ = this;
        that_.setState({lodings : true});
        that_.CenterO.childMethod()  //第一页跳第二页保存第一页数据
        let flag = true
        // let flag = that_.Validation_data(1);//验证第一页数据 所有必填项是否获得数据
        if(flag == false){
            that_.setState({lodings : false})
        }else{
            setTimeout(function(){ that_.setState({lodings : false}) }, 500);
        }    

        if(flag == true){
            that_.setState({lodings : true});
            setTimeout(function () {
                that_.CenterW.childMethod()  //第一页跳第二页回填数据
            }, 500);
            this.setState({
                headTxt: headTxt,
                htmls: 2,
            });
        }
    }

    btnClick_2() {
        let headTxt = '商户入网 > 商户基本信息'
        let that_ = this;
        that_.setState({lodings : true});
        that_.CenterW.childMethod()  //第二页跳第一页保存第二页数据
        setTimeout(function(){ that_.setState({lodings : false}) }, 500);
        setTimeout(function () {
            that_.CenterO.childMethod()  //第二页跳第一页回填数据
        }, 500)

        this.setState({
            headTxt: headTxt,
            htmls: 1,
        })

    }

    btnClick_3() {
        let headTxt = '商户入网 > 结算信息'
        let that_ = this;
        that_.setState({lodings : true});
        that_.CenterW.childMethod()  //第二页跳第三页保存第二页数据
        let flag = that_.Validation_data(2);//验证第二页数据 所有必填项是否获得数据

        if(flag == false){
            that_.setState({lodings : false})
        }else{
            setTimeout(function(){ that_.setState({lodings : false}) }, 500);
        }    
        
        if(flag == true){
            that_.setState({lodings : true});
            setTimeout(function () {
                that_.CenterS.childMethod()  //第二页跳第三页回填数据
            }, 500);
            this.setState({
                headTxt: headTxt,
                htmls: 3,
            });
        }
    }

    btnClick_4() {
        let headTxt = '商户入网 > 结算信息'
        let that_ = this;
        that_.setState({lodings : true});
        that_.CenterS.childMethod()  //第三页跳第二页保存第三页数据
        setTimeout(function(){ that_.setState({lodings : false}) }, 500);
        setTimeout(function () {
            that_.CenterW.childMethod()  //第三页跳第二页回填数据
        }, 500)

        this.setState({
            headTxt: headTxt,
            htmls: 2,
        })
    }



    getParams_o = (result, msg) => {
        this.setState({
            Params_o: msg
        })
    }

    getParams_w = (result, msg) => {
        // console.log(msg)
        this.setState({
            Params_w: msg
        })
    }

    getParams_s = (result, msg) => {
        this.setState({
            Params_S: msg
        })
    }

    btnClick() {
        let that_ = this;
        this.CenterS.childMethod(); //提取第三页数据
        let flag = that_.Validation_data(3);//验证第二页数据 所有必填项是否获得数据
        console.log(flag)
        that_.setState({lodings : true});
        if(flag == true){
            this.initData();
        }
    }
    initData() {
        let merchantType = JSON.parse(localStorage.getItem('userData')).merchantType;
        let merchantNo = JSON.parse(localStorage.getItem('userData')).merchantNo;
        let mallId = JSON.parse(localStorage.getItem('userData')).mallId; //上游提供
        let that_ = this;
        let url = '/payment/merchant.declaration.groovy'
        let params = {
            operationType: 'CREATE', // ：1：CREATE创建即入网，2：MODIFY更新即修改(审核通过前)
            name: JSON.parse(localStorage.getItem('userData')).userName,
            appName: merchantType == 2 ? merchantNo : '',
            parentAppName: merchantType == 2 ? mallId : '',
            mallId: merchantType == 3 ? mallId : '',
            merchantNo: merchantType == 3 ? merchantNo : '',//上游提供
            merchantType: merchantType,//ydy和商城的上游提供
            merchantInfo: {     //原首易信接口参数
                requestId: '', //订单号为商户自行拟定，提交的订单号必须在自身平台交易中唯一。商户平台不能以相同的订单号再次提交。
                operationType: 'CREATE', // ：1：CREATE创建即入网，2：MODIFY更新即修改(审核通过前)
                notifyUrl: '',//服务器通知：当订单状态发生变更后会向该地址发送五次通知，该地址可以带参数，如:“https://www.5upay.com/callback.action?test=test”.注意：如不填notifyUrl的参数值成功后您的服务器将得不到通知。
                extendedParameters: {//autoReview 是否跳过流程 TRUE 是， FALSE 否 sendActiveEmail 是否发送激活邮件 TRUE 是， FALSE 否 （这两项参数传递用”,”隔开，示例：autoReview:FALSE,sendActiveEmail:TRUE）
                    autoReview: false, sendActiveEmail: true
                },
                baseInfo: Object.assign(this.state.Params_o, this.state.Params_w, this.state.Params_S),
            }
        }
        $Axios('get', url, params, (res) => {
            console.log(res)
            that_.setState({lodings : false});

        })
    }



    render() {
        const { headTxt, htmls , lodings , btnType } = this.state;
        return (
            <div className={styleData.rootDom}>
                <div className={styleData.header_center}>
                    {headTxt}
                </div>
                <div className={styleData.main_center}>
                    <div className={styleData.center_ups}>
                        {lodings == true && <div style={{
                            width : '100%',
                            height : '100%',
                            textAlign : 'center',
                            paddingTop : '20%'
                        }}>
                            <Spin tip="页面加载中,请稍后...">
                
                            </Spin>
                        </div>}
                        {htmls === 1 && lodings == false && (<CenterO arr={this.state.Params_o} parent={this} onRef={this.bindRef_o}></CenterO>)}
                        {htmls === 2 && lodings == false && (<CenterW arr={this.state.Params_w} parent={this} onRef={this.bindRef_w}></CenterW>)}
                        {htmls === 3 && (<CenterS arr={this.state.Params_S} parent={this} onRef={this.bindRef_s}></CenterS>)}
                    </div>
                    <div className={styleData.center_bottom}>
                        {htmls === 1 && lodings == false &&  <Button className={styleData.btn, styleData.btn_next} type="primary" onClick={() => this.btnClick_1()} loading={btnType}>下一步</Button>}
                        {htmls === 2 && lodings == false &&  <Button className={styleData.btn, styleData.btn_xg} onClick={() => this.btnClick_2()} loading={btnType}>上一步</Button>}
                        {htmls === 2 && lodings == false &&  <Button className={styleData.btn, styleData.btn_next} type="primary" onClick={() => this.btnClick_3()} loading={btnType}>下一步</Button>}
                        {htmls === 3 && lodings == false &&  <Button className={styleData.btn, styleData.btn_xg} onClick={() => this.btnClick_4()} loading={btnType}>上一步</Button>}
                        {htmls === 3 && lodings == false &&  <Button className={styleData.btn, styleData.btn_next} type="primary" onClick={() => this.btnClick('ok')} loading={btnType}>提交</Button>}
                    </div>
                </div>
            </div>
        )
    }
}